#include "compito.h"

Tetris::Tetris(){
   for (int r=0; r<R; r++)
      for (int c=0; c<C; c++)
         s[r][c]=' ';
}

bool Tetris::verificaEOccupa(char f, int i, int j, bool occupa){
switch (f){
   case 'P':
	    if (s[i][j]==' '){
			   if (occupa)
				    s[i][j]=f;
			   return true;	
      }else
			return false;
	 case 'A':
      if ( i+2 >= R)
         return false;		
      if (s[i][j]==' ' && s[i+1][j]==' ' && s[i+2][j]==' '){
         if (occupa)
            s[i][j]=s[i+1][j]=s[i+2][j]=f;
			   return true;
      }else
         return false;
			
   case 'R':
      if ( i+1 >= R  || j+2 >= C)
         return false;		
      if (s[i][j]==' '   && s[i][j+1]==' '   && s[i][j+2]==' ' && 
		      s[i+1][j]==' ' && s[i+1][j+1]==' ' && s[i+1][j+2]==' '){
			   if (occupa)
				    s[i][j]=s[i][j+1]=s[i][j+2]=s[i+1][j]=s[i+1][j+1]=s[i+1][j+2]=f;
			   return true;
		  }else
         return false;
				
   default:
      cout<<"forma sconosciuta"<<endl;
      return false;
}
}
		
		
bool Tetris::ins(char f, int j){    
	 if (j<0 || j>=C)
		 return false;
	
	 bool ok=false;
	 int r=0;			
	 while( verificaEOccupa(f,r,j,false) ){
      r++;
		  ok = true;
	 }
	 r--;
	
	 if (ok){
      verificaEOccupa(f,r,j,true);
      return true;
   }else
      return false;
}

void Tetris::stampa(){
   for (int c=0; c<C; c++)
      cout<<'-';
   cout<<endl;
   for (int r=0; r<R; r++){
      for (int c=0; c<C; c++)
         cout<<s[r][c];
      cout<<endl;
   }
   for (int c=0; c<C; c++)
      cout<<'-';
   cout<<endl;
   for (int c=0; c<C; c++)
      cout<<c;
   cout<<endl<<endl;    
}


int Tetris::vuote(){
   int nrighevuote=0;
   bool vuota;
   int r;
   for(r=R-1; r>=0; r--){
      vuota = true;
      for (int c=0; c<C; c++)
         if (s[r][c]!=' ')
             vuota = false;
			   if (vuota)
				    nrighevuote++;
	 }
	 return nrighevuote;		
}

bool Tetris::confronta(const Tetris &t2){
   for (int r=R-2; r>=0; r--)
      for (int c=0; c<C; c++)
			   if ( (s[r][c]==' ' && t2.s[r][c]!=' ') || (s[r][c]!=' ' && t2.s[r][c]==' ') )
				    return false;
   return true;
}

bool Tetris::eliminaRigaPienaPiuInBasso(){
   bool piena;
   int r;
   for(r=R-1; r>=0; r--){
      piena = true;
			for (int c=0; c<C; c++)
         if (s[r][c]==' ')
            piena = false;
      if (piena)
         break;
   }
   if (piena){
      for (int i=r; i>0; i--)
         for (int c=0; c<C; c++)
            s[i][c]=s[i-1][c];
         for (int c=0; c<C; c++)
            s[0][c]=' ';
         return true;
   }else
      return false;
}
